//+------------------------------------------------------------------+
//|                                                 LowHighCount.mq4 |
//|                        Copyright 2012, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Copyright 2012, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net"

extern string ____0____="Low=true   High=false";
extern bool LoworHigh=true;
extern string ____1____="enter specific tag for multiple Bar Counting";
extern int tag=1; 
extern int numberofbarsbefore=7;
extern int numberofbarsafter=7;
extern int pipsbelowabovecandle=5;
extern color numbercolor=Red;
extern color VerticalLineColor=Red;

int i, pivotbarsago;
int periode,periodedrawn;
string symbole,symboledrawn;
#property indicator_chart_window
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
      for(i=(pivotbarsago-numberofbarsafter-1);i>=0;i--)
         {
            if(ObjectFind("Low"+tag+"_"+i) != -1)
            {
            ObjectDelete("Low"+tag+"_"+i);
            } 
            if(ObjectFind("High"+tag+"_"+i) != -1)
            {
            ObjectDelete("High"+tag+"_"+i);
            }    
        }
//DeleteObjects();
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   int    counted_bars=IndicatorCounted(), beforecounter=0,aftercounter=0;
   double startlow,starthigh;
   
   periode=Period();
   symbole=Symbol();
   if(periodedrawn!=periode||symboledrawn!=symbole)
   {     
          for(i=(pivotbarsago-numberofbarsafter-1);i>=0;i--)
         {
            if(ObjectFind("Low"+tag+"_"+i) != -1)
            {
            ObjectDelete("Low"+tag+"_"+i);
            } 
            if(ObjectFind("High"+tag+"_"+i) != -1)
            {
            ObjectDelete("High"+tag+"_"+i);
            }    
        }
   } 
   
//----
if(LoworHigh)
{
   beforecounter=0;
   aftercounter=0;
   if (ObjectFind("LOW"+tag) == -1)
   {            
    ObjectCreate("LOW"+tag, OBJ_VLINE, 0, Time[40], 0);
    ObjectSet("LOW"+tag,OBJPROP_COLOR,VerticalLineColor);
    ObjectSet("LOW"+tag,OBJPROP_STYLE,STYLE_DOT);
    ObjectCreate("LOWLabel"+tag,OBJ_TEXT,0, Time[40], 0);
    ObjectSetText("LOWLabel"+tag,"Low"+tag,0,"Times New Roman", VerticalLineColor);
   }
   if (ObjectFind("HIGH"+tag) != -1)
   { 
     ObjectDelete("HIGH"+tag);
   }  
   if(ObjectFind("LOWLabel"+tag) != -1)
   {
      ObjectMove("LOWLabel"+tag,0,ObjectGet("LOW"+tag,OBJPROP_TIME1),iLow(NULL,0,iBarShift(NULL,0,ObjectGet("LOW"+tag,OBJPROP_TIME1))));
   } 
   startlow=iLow(NULL,0,iBarShift(NULL,0,ObjectGet("LOW"+tag,OBJPROP_TIME1)));
   pivotbarsago=iBarShift(NULL,0,ObjectGet("LOW"+tag,OBJPROP_TIME1));

//   Comment(DoubleToStr(startlow,4));
//   Comment(pivotbarsago);
   
   for(i=(pivotbarsago+1);i<=(pivotbarsago+numberofbarsbefore);i++)
   {
      if(Low[i]>=Low[pivotbarsago])
         beforecounter++;
   }
   if(beforecounter<numberofbarsbefore)
   {
   Comment("No Valid LOW considering numberofbarsbefore");
   return(0);
   }
   else
   {
      Comment("Valid Low");
      for(i=(pivotbarsago-numberofbarsafter);i<=(pivotbarsago-1);i++)
      {
         if(Low[i]>=Low[pivotbarsago])
         aftercounter++;
      }  
      if(beforecounter<numberofbarsafter)
      {
      Comment("No Valid LOW considering numberofbarsafter");
      return(0);
      }
      else
      {
         for(i=(pivotbarsago-numberofbarsafter-1);i>=0;i--)
         {
            if(ObjectFind("Low"+tag+"_"+i) == -1)
            {
            ObjectCreate("Low"+tag+"_"+i,OBJ_TEXT,0,iTime(NULL,0,i),Low[i]-pipsbelowabovecandle*Point);
            ObjectSet("Low"+tag+"_"+i,OBJPROP_COLOR,numbercolor);
            ObjectSetText("Low"+tag+"_"+i,DoubleToStr(MathAbs(pivotbarsago-numberofbarsafter-i),0));
            periodedrawn=Period();
            symboledrawn=Symbol();
            }
         }
      }
   
   }
     
     
   
}
else
{
   beforecounter=0;
   aftercounter=0;
   if (ObjectFind("HIGH"+tag) == -1)
   {            
    ObjectCreate("HIGH"+tag, OBJ_VLINE, 0, Time[40], 0);
    ObjectSet("HIGH"+tag,OBJPROP_COLOR,VerticalLineColor);
    ObjectSet("HIGH"+tag,OBJPROP_STYLE,STYLE_DOT);
    ObjectCreate("HIGHLabel"+tag,OBJ_TEXT,0, Time[40], 0);
    ObjectSetText("HIGHLabel"+tag,"High"+tag,0,"Times New Roman", VerticalLineColor);
   }
   if (ObjectFind("LOW"+tag) != -1)
   { 
     ObjectDelete("LOW"+tag);
   } 
   if(ObjectFind("HIGHLabel"+tag) != -1)
   {
      ObjectMove("HIGHLabel"+tag,0,ObjectGet("HIGH"+tag,OBJPROP_TIME1),iHigh(NULL,0,iBarShift(NULL,0,ObjectGet("HIGH"+tag,OBJPROP_TIME1))));
   }
   starthigh=iHigh(NULL,0,iBarShift(NULL,0,ObjectGet("HIGH"+tag,OBJPROP_TIME1)));
   pivotbarsago=iBarShift(NULL,0,ObjectGet("HIGH"+tag,OBJPROP_TIME1));

//   Comment(DoubleToStr(startlow,4));
//   Comment(pivotbarsago);
   
   for(i=(pivotbarsago+1);i<=(pivotbarsago+numberofbarsbefore);i++)
   {
      if(High[i]<=High[pivotbarsago])
         beforecounter++;
   }
   if(beforecounter<numberofbarsbefore)
   {
   Comment("No Valid HIGH considering numberofbarsbefore");
   return(0);
   }
   else
   {
      Comment("Valid HIGH");
      for(i=(pivotbarsago-numberofbarsafter);i<=(pivotbarsago-1);i++)
      {
         if(High[i]<=High[pivotbarsago])
         aftercounter++;
      }  
      if(aftercounter<numberofbarsafter)
      {
      Comment("No Valid HIGH considering numberofbarsafter");
      return(0);
      }
      else
      {
         for(i=(pivotbarsago-numberofbarsafter-1);i>=0;i--)
         {
            if(ObjectFind("High"+tag+"_"+i) == -1)
            {
            ObjectCreate("High"+tag+"_"+i,OBJ_TEXT,0,iTime(NULL,0,i),High[i]+5*pipsbelowabovecandle*Point);
            
            ObjectSetText("High"+tag+"_"+i,DoubleToStr(MathAbs(pivotbarsago-numberofbarsafter-i),0));
            ObjectSet("High"+tag+"_"+i,OBJPROP_COLOR,numbercolor);
            periodedrawn=Period();
            symboledrawn=Symbol();
            }
         }
      }
   
   }
     
     
   
}


   
   
//----
   return(0);
  }
//+------------------------------------------------------------------+

